lwl = 0;
lwr = 0;
lwt = 0;
lwb = 0;
doDebug = 0;

idDeviceActive = 0;
idDeviceLeft = 1;
idDeviceTop = 2;
idDeviceRight = 3;
idDeviceBottom = 4;
idDeviceNum = 5;
idDeviceRow = 6;
idDeviceColumn = 7;
idOrigDeviceX = 8;
idOrigDeviceY = 9;

function InitDevices()
	local c = 1;
	local i = 0;
	local j = 0;

	for i = 1, rows do
		for j = 1, columns do
			lsPrintln("Setting device #" .. c);
			devices[c] = {};
			devices[c][idDeviceActive] = 1;
			devices[c][idDeviceLeft] = start_x + (deviceWidth * (j - 1));
			devices[c][idDeviceTop] = start_y + (deviceHeight * (i - 1));
			devices[c][idDeviceRight] = 0;
			devices[c][idDeviceBottom] = 0;
			devices[c][idDeviceNum] = c;
			devices[c][idDeviceRow] = i;
			devices[c][idDeviceColumn] = j;
			devices[c][idOrigDeviceX] = start_x + (deviceWidth * (j - 1));
			devices[c][idOrigDeviceY] = start_y + (deviceHeight * (i - 1));
			c = c + 1;
		end
	end
end

function GetDeviceLocations()
	-- Wait for release if it''s already held
	while lsShiftHeld() do end;
	-- Display message until shift is held
	while not lsShiftHeld() do
		lsPrintWrapped(0, 0, 0, lsScreenX, 0.7, 0.7, 0xFFFFFFff, "Mouse over center of STARTING device and press shift.");
		lsSetCaptureWindow();
		start_x, start_y = srMousePos();
		lsPrintWrapped(0, 40, 0, lsScreenX, 0.7, 0.7, 0xB0B0B0ff, start_x .. ", " .. start_y);
		lsDoFrame();
		if lsButtonText(lsScreenX - 110, lsScreenY - 30, 0, 100, 0xFFFFFFff, "Exit") then
			error "Cancelled";
		end
	end
	lsSetCaptureWindow();
	-- Wait for shift to be released
	while lsShiftHeld() do end;
	
	lsPrintln("First Device set @ " .. start_x .. "," .. start_y);
	while not lsShiftHeld() do
		lsPrintWrapped(0, 0, 1, lsScreenX, 0.7, 0.7, 0xFFFFFFff, "Mouse over center of ENDING device and press shift.");
		lsSetCaptureWindow();
		end_x, end_y = srMousePos();
		lsPrintWrapped(0, 40, 1, lsScreenX, 0.7, 0.7, 0xB0B0B0ff, end_x .. ", " .. end_y);
		lsDoFrame();
		if lsButtonText(lsScreenX - 110, lsScreenY - 30, 0, 100, 0xFFFFFFff, "Exit") then
			error "Cancelled";
		end
	end
	lsSetCaptureWindow();
	-- Wait for shift to be released
	while lsShiftHeld() do end;
	lsPrintln("Last Device set @ " .. end_x .. "," .. end_y);
end

function CalculateNewLocation(r, c)
	local x = xyWindowSize[0] - 2 - ((c-1) * 15);
	local y = 2 + ((r-1) * 15);
	return x,y
end

function DeviceLocSize(d)
	local l = devices[d][idDeviceLeft];
	local t = devices[d][idDeviceTop];
	local w = devices[d][idDeviceRight] - devices[d][idDeviceLeft];
	local h = devices[d][idDeviceBottom] - devices[d][idDeviceTop];
	return l,t,w,h;
end

function setWaitSpot(x0, y0)
	setWaitSpot_x = x0;
	setWaitSpot_y = y0;
	setWaitSpot_px = srReadPixel(x0, y0);
end

function drag(x0, y0, x1, y1)
	lsPrintln("Dragging from " .. x0 .. "," .. y0 .. " to " .. x1 .. "," .. y1);
	local oX,oY = srMousePos();
	srSetMousePos(x0, y0);
	setWaitSpot (x1, y1);
	srMouseDown(x0, y0, 0);
	srSetMousePos(x1, y1);
	lsSleep(delay);
	srMouseUp(x0, y0, 0);
	srSetMousePos(oX,oY);
	lsSleep(delay);
end

function waitForChange(timeout)
	if not timeout then
		timeout = 10000000;
	end
	local c=0;
	local timestart = lsGetTimer();
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
		if lsGetTimer() > timestart + timeout then
			lsPrintln('Timed out waiting.');
		end
	end
	lsPrintln('Waited ' .. c .. 'ms for pixel to change.');
end

function OpenMenu(x, y, nomove)
	if not nomove then
		nomove = 0;
	end
	lsPrintln("Set Wait Spot: " .. x+5 .. "," .. y);
	setWaitSpot(x+5, y);
	if nomove == 1 then
		lsPrintln("Clicking No move : " .. x .. "," .. y);
		srClickMouseNoMove(x, y);
	else
		lsPrintln("Clicking : " .. x .. "," .. y);
		srClickMouse(x, y);
	end
	lsPrintln("Waiting for change");
	waitForChange();
	lsSleep(10);
	local menu = srGetWindowBorders(x+5,y);
	return menu;
end

function PinWindow(x, y)
	srReadScreen();
	local win = srGetWindowBorders(x, y);
	local pin = srFindImageInRange("pin.png",win[0],win[1],win[2]-win[0],win[3]-win[1]);
	srClickMouseNoMove(pin[0],pin[1]);
end

function ClickMouseNoMove(x, y)
	local oX,oY = srMousePos();
	srMouseUp(oX,oY,0);
	srSetMousePos(x, y);
	srClickMouseNoMove(x, y);
	srSetMousePos(oX,oY);
end

function WaitForImage(imageName, t, e)
	lsPrintln("Looking for " .. imageName);
	if t == nil then
		t = 1000;
	end
	if e == nil then
		e = 0;
	end
	while 1 do
		checkBreak();
		srReadScreen();
		btn = findAllImages(imageName);
		if #btn > 0 then
			break;
		end
		lsSleep(100);
		t = t - 100;
		if t < 0 then
			if e == 1 then
				error("Timeout Occured while waiting for image.");
			else
				lsPrintln("Timeout Occured while waiting for image.");
				break;
			end
		end
	end
	if #btn > 0 then
		lsPrintln(imageName .. " found.");
	else
		lsPrintln(imageName .. " not found.");
	end
	return btn;
end

function GetWindowBorders(x, y)
	local l = x;
	local r = x;
	local t = y;
	local b = y;
	local ol = x;
	local ot = y
	lsPrintln("Looking for Window Borders at " .. x .. "x" .. y);
	srReadScreen();
	
	lsPrintln("Looking for Left side");
	while 1 do
		checkBreak();
		p = srReadPixelFromBuffer(l, ot);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		l = l - 1;
		if l < 1 then
			l = 1
			break;
		end
	end
	
	lsPrintln("Looking for Right side");
	while 1 do
		checkBreak();
		p = srReadPixelFromBuffer(r, ot);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		r = r + 1;
		if r > xyWindowSize[0]-1 then
			r = xyWindowSize[0]-1;
			break;
		end
	end
	
	lsPrintln("Looking for Top side");
	while 1 do
		checkBreak();
		p = srReadPixelFromBuffer(ol, t);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		t = t - 1;
		if t < 1 then
			t = 1;
			break;
		end;
	end
	
	lsPrintln("Looking for Bottom side");
	while 1 do
		checkBreak();
		p = srReadPixelFromBuffer(ol, b);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		b = b + 1;
		if b > xyWindowSize[1] - 1 then
			b = xyWindowSize[1]-1;
			break;
		end
	end
	
	l = l - 1;
	r = r + 1;
	t = t - 1;
	b = b + 1;
	return l,r,t,b;
end

function GetCoordinates()
	lsPrintln("Start GetCoordinates");
	srReadScreen();
	local st = srFindImageInRange("colon.png", lwl, lwt, lwr-lwl, lwb-lwt);
	local xCoord = ocrNumber(st[0] + 7, st[1]);
	local uv = srFindImageInRange("comma.png", st[0], st[1], lwr-st[0], lwb-st[1]);
	local yCoord = ocrNumber(uv[0] + 8, uv[1]);
	lsPrintln("Coords are " .. xCoord .. "," .. yCoord);
	lsPrintln("End GetCoordinates");
	
	return xCoord, yCoord
end

function ocrNumber(x, y)
	lsPrintln("Start ocrNumber");
	-- find first number
	local digit=nil;
	local offset=0;
	while (not digit) and (offset < 10) do
		for i=0, 9 do
			local pos = srFindImageInRange(i .. ".png", x, y, 6, 9, tol);
			if pos then
				digit=i;
				break;
			end
		end
		if not digit then
			x = x+1;
			offset = offset + 1;
		end
	end
	if (offset > 0) then
		lsPrintln("Perf warning: OCR non-0 offset of " .. offset);
	end
	local ret = digit;
	while 1 do
		digit = nil;
		x = x + 7;
		for i=0, 9 do
			local pos = srFindImageInRange(i .. ".png", x, y, 6, 9, tol);
			if pos then
				digit=i;
				break;
			end
		end
		if digit then
			ret = ret * 10 + digit;
		else
			break;
		end
	end
	lsPrintln("End ocrNumber");
	return ret;
end
function iocrNumber(x, y)
	local tol = 10000;
	lsPrintln("Start ocrNumber");
	lsPrintln("Looking at " .. x .. "," .. y);
	-- find first number
	local digit=nil;
	local offset=0;
	while (not digit) and (offset < 10) do
		for i=0, 9 do
			local pos = srFindImageInRange("incense/" .. i .. ".png", x, y, 6, 9, tol);
			if pos then
				lsPrintln("Digit " .. i .. " found at " .. x .. "," .. y);
				digit=i;
				break;
			end
		end
		if not digit then
			x = x+1;
			offset = offset + 1;
		end
	end
	
	if (offset > 0) then
		lsPrintln("Perf warning: OCR non-0 offset of " .. offset);
	end
	local ret = digit;
	while 1 do
		digit = nil;
		x = x + 7;
		for i=0, 9 do
			local pos = srFindImageInRange("incense/" .. i .. ".png", x, y, 6, 9, tol);
			if pos then
				lsPrintln("Digit " .. i .. " found at " .. x .. "," .. y);
				digit=i;
				break;
			end
		end
		if digit then
			ret = ret * 10 + digit;
		else
			break;
		end
	end
	lsPrintln(ret);
	lsPrintln("End ocrNumber");
	return ret;
end
function ocrbNumber(x, y)
	--lsPrintln("Start ocrbNumber");
	tol = 10000;
	local pos = nil;
	-- find first number
	local digit=nil;
	local offset=0;
	while (not digit) and (offset < 10) do
		for i=0, 9 do
			--lsPrintln("Looking for " .. i .. " @ " .. x .. "," .. y);
			--lsPrintln("srFindImageInRange('b' .. " .. i .. " .. '.png', " .. x .. ", " .. y .. ", 5, 8, " .. tol .. ");");
			--if i == 1 then
			--	pos = srFindImageInRange("b" .. i .. ".png", x, y, 4, 9, tol);
			--else
				pos = srFindImageInRange("b" .. i .. ".png", x, y, 6, 9, tol);
			--end
			if pos then
				--lsPrintln("Found " .. i .. " @ " .. x .. "," .. y);
				digit=i;
				y = pos[1];
				break;
			end
		end
		if not digit then
			x = x+1;
			offset = offset + 1;
		end
	end
	--if (offset > 0) then
	--	lsPrintln("Perf warning: OCR non-0 offset of " .. offset);
	--end
	local ret = digit;
	while 1 do
		digit = nil;
		--if i == 1 then
		--	x = x + 5;
		--else
		  x = x + 6;
		--end
		--x = x + 6;
		for i=0, 9 do
			--lsPrintln("Looking for " .. i .. " @ " .. x .. "," .. y);
			--if i == 1 then
			--	pos = srFindImageInRange("b" .. i .. ".png", x, y, 4, 9, tol);
			--else
				pos = srFindImageInRange("b" .. i .. ".png", x, y, 6, 9, tol);
			--end
			if pos then
				--lsPrintln("Found " .. i .. " @ " .. x .. "," .. y);
				digit=i;
				break;
			end
		end
		if digit then
			ret = ret * 10 + digit;
		else
			break;
		end
	end
	--lsPrintln("End ocrNumber");
	return ret;
end
function debug(message)
	if doDebug then
		local f = io.open("debug.log","a+");
		f:write(message .. "\n");
		f:close();
	end
end